<template>
  <div class="q-mt-lg-lg-xs">
    <q-spinner-cube
      class="fixed-center"
      color="primary"
      size="5em"
      v-if="isLoadingShops"
    />
    <q-list>
      <div v-for="shop in shopList" :key="shop.id">
        <q-item>
          <q-item-section avatar>
            <q-item-label>
              <q-icon name="crop_original" size="lg"/>
            </q-item-label>
          </q-item-section>
          <q-item-section>
            <q-item-label lines="1">{{ shop.title }}</q-item-label>
            <q-item-label caption>
              {{ shop.description }}
            </q-item-label>
            <q-item-label caption>
              {{ shop.radius }}m
            </q-item-label>
          </q-item-section>
          <q-item-section side>
            <div class="text-grey-8 q-gutter-xs">
              <q-btn push size="md" dense round flat @click="onAddToFavouritesTapped(shop)">
                <q-icon v-if="isFavourite(shop)" name="star"/>
                <q-icon v-else name="star_border"/>
              </q-btn>
            </div>
          </q-item-section>
        </q-item>
      </div>
    </q-list>
  </div>
</template>

<script>

import { favouritesShopsRepository } from 'src/public/FavouritesShopRepository'

export default {
  title: 'ShopListPage',
  props: {
    useDefaultData: {
      type: Boolean,
      default: true
    },
    shopList: {
      type: Array,
      default: () => { return [] }
    }
  },
  data: () => {
    return {
      isLoadingShops: true,
      favourites: []
    }
  },
  methods: {
    isFavourite (shop) {
      return this.favourites.find(s => s.title === shop.title) !== undefined
    },
    onAddToFavouritesTapped (shop) {
      if (this.isFavourite(shop)) {
        favouritesShopsRepository.removeById(shop.id)
        this.favourites.splice(this.favourites.indexOf(shop), 1)
        if (!this.useDefaultData) {
          this.shops.splice(this.shopList.indexOf(shop), 1)
        }
      } else {
        favouritesShopsRepository.save(shop)
        this.favourites.push(shop)
      }
    }
  },
  async mounted () {
    this.favourites = await favouritesShopsRepository.getAll()
    if (this.useDefaultData) {
      // eslint-disable-next-line vue/no-mutating-props
      this.shopList = [
        {
          id: '1',
          title: 'Apteka Silesia',
          radius: 100,
          position: {
            lat: 51.08529,
            lng: 17.01082
          },
          description: 'Some fancy description'
        }, {
          id: '2',
          title: 'Lidl',
          radius: 100,
          position: {
            lat: 51.07641,
            lng: 17.00647
          },
          description: 'Some fancy description'
        }, {
          id: '3',
          title: 'Biedronka',
          radius: 100,
          position: {
            lat: 51.09185,
            lng: 17.00702
          },
          description: 'Some fancy description'
        }
      ]
    } else {
      this.shops = this.shopList
    }
    this.isLoadingShops = false
  }
}
</script>

<style scoped>

</style>
